/*************************************************************************
 * ArtisticStylePlugin: Using Artistic Style at Qt Creator.              *
 * Copyright (C) 2010-2011  Lorenz Haas <lykurg@gmail.com>               *
 *                                                                       *
 * This program is free software: you can redistribute it and/or modify  *
 * it under the terms of the GNU General Public License as published by  *
 * the Free Software Foundation, either version 3 of the License, or     *
 * (at your option) any later version.                                   *
 *                                                                       *
 * This program is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 * GNU General Public License for more details.                          *
 *                                                                       *
 * You should have received a copy of the GNU General Public License     *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *************************************************************************/

#ifndef ARTISTICSTYLEITERATOR_H
#define ARTISTICSTYLEITERATOR_H

#include "astyle/astyle.h"

#include <QString>
class QTextStream;

namespace ArtisticStyle
{
  namespace Internal
  {
    class ArtisticStyleIterator : public astyle::ASSourceIterator
    {
      public:
        ArtisticStyleIterator(QTextStream* stream);
        ~ArtisticStyleIterator();
        bool checkForEmptyLine;
        const char* getOutputEOL() const;
        bool compareToInputBuffer(const std::string& nextLine) const;
        bool hasMoreLines() const;
        std::string nextLine(bool emptyLineWasDeleted = false);
        std::string peekNextLine();
        void peekReset();
        bool getLineEndChange(int /*lineEndFormat*/) const;
        void saveLastInputLine();

      private:
        QTextStream* m_stream;
        QString m_buffer;
        QString m_prevBuffer;
        bool m_prevLineDeleted;
        int m_peekStart;
    };
  }
}

#endif // ARTISTICSTYLEITERATOR_H
